using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Grid;

namespace TwoColGridSamp
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
        private Syncfusion.Windows.Forms.Grid.GridControl grid;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

        private HScrollBar hScrollBar = new HScrollBar();
        private VScrollBar vScrollBar = new VScrollBar();

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

            grid.QueryCellInfo += new GridQueryCellInfoEventHandler(grid_QueryCellInfo);
            grid.QueryColCount += new GridRowColCountEventHandler(grid_QueryColCount);
            grid.QueryRowCount += new GridRowColCountEventHandler(grid_QueryRowCount);
            grid.ColWidthsChanged += new GridRowColSizeChangedEventHandler(grid_ColWidthsChanged);

//            grid.Rows.HeaderCount = -1;
//            grid.Properties.RowHeaders = false;

            grid.ResetVolatileData();

            this.Controls.Add(hScrollBar);
            this.Controls.Add(vScrollBar);
            grid.UseSharedScrollBars = true;
            grid.VScrollBar.InnerScrollBar = vScrollBar;
            grid.HScrollBar.InnerScrollBar = hScrollBar;

            grid.HScrollBehavior = GridScrollbarMode.Automatic | 
                GridScrollbarMode.AutoScroll | 
                GridScrollbarMode.Shared;
            grid.VScrollBehavior = GridScrollbarMode.Automatic | 
                GridScrollbarMode.AutoScroll | 
                GridScrollbarMode.Shared;
            PerformLayout();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.grid = new Syncfusion.Windows.Forms.Grid.GridControl();
            ((System.ComponentModel.ISupportInitialize)(this.grid)).BeginInit();
            this.SuspendLayout();
            // 
            // grid
            // 
            this.grid.Location = new System.Drawing.Point(40, 24);
            this.grid.Name = "grid";
            this.grid.Size = new System.Drawing.Size(216, 200);
            this.grid.SmartSizeBox = false;
            this.grid.TabIndex = 0;
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(292, 273);
            this.Controls.Add(this.grid);
            this.Name = "Form1";
            this.Text = "Form1";
            ((System.ComponentModel.ISupportInitialize)(this.grid)).EndInit();
            this.ResumeLayout(false);

        }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
        }

        private void grid_QueryCellInfo(object sender, GridQueryCellInfoEventArgs e)
        {

        }

        private void grid_QueryColCount(object sender, GridRowColCountEventArgs e)
        {
            e.Count = 2;
            e.Handled = true;
        }

        private void grid_QueryRowCount(object sender, GridRowColCountEventArgs e)
        {
            e.Count = 5;
            e.Handled = true;
        }

        protected override void OnLayout(LayoutEventArgs levent)
        {
            hScrollBar.Location = new Point(grid.Left, grid.Bottom + 1);
            hScrollBar.Size = new Size(grid.Bounds.Width - vScrollBar.Width, hScrollBar.Height);
            vScrollBar.Location = new Point(grid.Right + 1, grid.Top);
            vScrollBar.Size = new Size(vScrollBar.Width, grid.Bounds.Height - hScrollBar.Height);
            base.OnLayout (levent);
        }

        private void grid_ColWidthsChanged(object sender, GridRowColSizeChangedEventArgs e)
        {
            PerformLayout();
        }
    }
}
